<?php
// Show Poll
function pro_poll_wgt( $id, $width = '', $vote_button = '' )
{
	global $wpdb, $wp_poll_path, $current_user;
	get_currentuserinfo();
	
	$poll = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."pro_poll WHERE id = ".$id." LIMIT 1");
	$poll_options = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."pro_poll_options WHERE pid = ".$id." ORDER BY options_nr ASC" );
	$display_poll = 1;
	
	if( $poll )
	{
		// Check if user can still vote for this poll
		if( $poll[0]->limit_vote_by == 'cookie' && isset( $_COOKIE["wp_pro_poll_system_".$id]) )
		{
			$display_poll = 0;
		}
		if( $poll[0]->limit_vote_by == 'ip_address' )
		{
			$ip_check = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."pro_poll_votes WHERE pid = ".$id." AND ip_address = '".$_SERVER["REMOTE_ADDR"]."' " );
			if( $ip_check )
			{
				$display_poll = 0;
			}
		}
		if( $poll[0]->limit_vote_by == 'user' )
		{
			$usr_check = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."pro_poll_votes WHERE pid = ".$id." AND uid = '".$current_user->ID."' " );
			if( $usr_check )
			{
				$display_poll = 0;
			}
		}
		if( !$poll[0]->poll_status )
		{
			$display_poll = 0;
		}
		
		
		
		$poll_width = $width ? ' width:'.$width.'px; ' : '';
		$title_color = !empty( $poll[0]->title_color ) ? 'style="color:'.$poll[0]->title_color.';"' : '';
		$option_color = !empty( $poll[0]->option_color ) ? 'style="color:'.$poll[0]->option_color.';"' : '';
		$vote_txt_color = !empty( $poll[0]->vote_txt_color ) ? ' color:'.$poll[0]->vote_txt_color.'; ' : '';
		$poll_bg_color = !empty( $poll[0]->poll_bg_color ) ? ' background-color:'.$poll[0]->poll_bg_color.'; ' : '';
		$button_possition = $vote_button == 'right' ? 'right' : '';
			
		if( $display_poll )
		{
			?>
			<div class="pro_poll_container" style=" <?php echo $poll_width. ' '.$poll_bg_color; ?>">
				<div class="pro-poll-result pro-poll-result<?php echo $poll[0]->id; ?>"></div>
				
				<div class="pro-poll-vote pro-poll-vote<?php echo $poll[0]->id; ?>">
					<h3 <?php echo $title_color; ?>><?php echo $poll[0]->title; ?></h3>
					<form id="poll_vote_form_<?php echo $poll[0]->id; ?>" action="" method="post" enctype="multipart/form-data">
					<?php
					foreach( $poll_options as $k => $opt )
					{
						?>
						<div <?php echo $option_color; ?>>
                        	<input type="radio" class="poll_vote_option" name="option" value="<?php echo $opt->id; ?>" /> <!--<div class="poll_option_label">--><?php echo $opt->options; ?><!--</div>-->
                        </div>
						<?php
					}
					
					// Check if user can vote
					if( !$poll[0]->login_to_vote || $poll[0]->login_to_vote && is_user_logged_in() )
					{
						?>
                        <a id="poll_vote_<?php echo $poll[0]->id; ?>" class="poll_vote_btn <?php echo $button_possition; ?>" style="background:<?php echo $poll[0]->progress_color; ?>; <?php echo $vote_txt_color; ?>"><?php _e('vote', 'wppropoll'); ?></a>
                        <?php
                    }
					else
					{
						?>
						<a class="poll_vote_btn <?php echo $button_possition; ?>" href="<?php bloginfo('url'); ?>/wp-login.php" style="background:<?php echo $poll[0]->progress_color; ?>; <?php echo $vote_txt_color; ?>"><?php _e('login to vote', 'wppropoll'); ?></a>
                        <?php
					}
					?>
                    
                    <div class="loading loading-<?php echo $poll[0]->id; ?>" <?php echo $option_color; ?>><?php _e('Loading', 'wppropoll'); ?>...</div>
                    
					<?php
					// If results can bee seen without voting
					if( $poll[0]->show_results )
					{
					?>
                    	<a id="show_results_<?php echo $poll[0]->id; ?>" class="show_results_btn <?php echo $button_possition; ?>" <?php echo $option_color; ?>>
                        	<small><?php _e('show results', 'wppropoll'); ?></small>
                        </a>
                        <?php
					}
					?>
                    	<div style="clear:both;"></div>
					</form>
				</div>
			</div><!-- end pro_poll_container -->
		   
			
			<script type="text/javascript">
			jQuery(document).ready(function($){
				
				var ajaxurl = '<?php echo admin_url('admin-ajax.php'); ?>';
				
				// SAVE VOTE
				$('#poll_vote_<?php echo $poll[0]->id; ?>').click(function(){
					
					if( $('input[name=option]:checked', '#poll_vote_form_<?php echo $poll[0]->id; ?>').val() )
					{	
						$('#poll_vote_<?php echo $poll[0]->id; ?>').hide();
						$('.loading-<?php echo $poll[0]->id; ?>').show();
						$.ajax({
						   type: "POST",
						   url: ajaxurl,
						   data: "action=save_pro_poll_vote&id=<?php echo $poll[0]->id; ?>&optId="+ $('input[name=option]:checked', '#poll_vote_form_<?php echo $poll[0]->id; ?>').val(),
						   success: function( msg ){
								$('.loading-<?php echo $poll[0]->id; ?>').hide();
								$('.pro-poll-vote<?php echo $poll[0]->id; ?>').hide();
								$('.pro-poll-result<?php echo $poll[0]->id; ?>').html( msg );
								//alert( "Data Saved: " + msg );
								
						   }
						});
					}
					else
					{
						alert( '<?php _e('Please select an option', 'wppropoll'); ?>' );
					}
					
				});
				
				
				$('#show_results_<?php echo $poll[0]->id; ?>').click(function(){
	
					$('.loading-<?php echo $poll[0]->id; ?>').show();
					$.ajax({
					   type: "POST",
					   url: ajaxurl,
					   data: "action=pro_poll_vote_get_results&id=<?php echo $poll[0]->id; ?>",
					   success: function( msg ){
							
							$('.loading-<?php echo $poll[0]->id; ?>').hide();
							$('.pro-poll-vote<?php echo $poll[0]->id; ?>').hide();
							$('.pro-poll-result<?php echo $poll[0]->id; ?>').html( msg );
							//alert( "Data Saved: " + msg );
					   }
					});
					
				});	
				
			});
			</script>
			<?php
		}
		else
		{
			?>
            <div class="pro_poll_container" style=" <?php echo $poll_width. ' '.$poll_bg_color; ?>">
            	<div class="pro-poll-result pro-poll-result<?php echo $poll[0]->id; ?>">
            		<?php pro_poll_results_wgt( $id ); ?>
                </div>
            </div><!-- end pro_poll_container -->
            <?php
		}
	}
}






// Show poll results
function pro_poll_results_wgt( $id )
{
	global $wpdb, $wp_poll_path;
	
	$poll = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."pro_poll WHERE id = ".$id." LIMIT 1");
	$poll_options = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."pro_poll_options WHERE pid = ".$id." ORDER BY options_nr ASC" );
	
	// Get total amount of votes
	foreach( $poll_options as $opt )
	{
		$total = $total + $opt->votes;	
	}
	
	// Get results
	foreach( $poll_options as $k => $opt )
	{
		$result[$k] = array(
			'percent' => $opt->votes ? number_format(($opt->votes * 100) / $total) : 0,
			'votes'   => $opt->votes,
			'option'  => $opt->options
		);
	}
	
	// Output results
	$title_color = !empty( $poll[0]->title_color ) ? 'style="color:'.$poll[0]->title_color.';"' : '';
	$option_color = !empty( $poll[0]->option_color ) ? 'style="color:'.$poll[0]->option_color.';"' : '';
	
	if( $poll[0]->show_results_after_voting )
	{
	?>
	<div class="poll-results">
    	<h3 <?php echo $title_color; ?>><?php echo $poll[0]->title; ?></h3>
		<?php
		foreach( $result as $k => $res )
		{
			if( !$poll[0]->show_percentage )
			{
				$showP_V = $result[$k]['percent'];
				$pc = '%';
			}
			elseif( $poll[0]->show_percentage == 1 )
			{
				$showP_V = $result[$k]['votes'];
				$pc = ' '.__('votes', 'wppropoll');
			}
			elseif( $poll[0]->show_percentage == 2 )
			{
				$showP_V = $result[$k]['percent'];
				$show_vts = ' votes="'.$result[$k]['votes'].'" ';
				$pc = '%';
			}
			//$showP_V = $poll[0]->show_percentage ? $result[$k]['votes'] : $result[$k]['percent'];
			
			?>
			<div style="margin:0 0 10px 0;">
				<div style="float:left;"><div <?php echo $option_color; ?>><?php echo $result[$k]['option']; ?></div></div>
				<div class="percent-progress percent-progress<?php echo $poll[0]->id; ?>" data-value="<?php echo $showP_V;?>" <?php echo $show_vts; ?> style="float:right; color:<?php echo $poll[0]->progress_color; ?>;"><?php echo $showP_V; ?><?php echo $pc; ?></div>
				<div style="clear:both;"></div>
				
				<div style="background:<?php echo $poll[0]->progress_bg_color; ?>;">
					<div class="poll-results-bar poll-results-bar<?php echo $poll[0]->id; ?>" data-value="<?php echo $result[$k]['percent']; ?>" style="background:<?php echo $poll[0]->progress_color; ?>; height:5px; width:<?php echo $result[$k]['percent']; ?>%;"></div>
				</div>
			</div>
			<?php
		}
		
		// Show the amount of votes
		if( $poll[0]->show_am_votes )
		{
			?>
        	<div class="poll-am-votes" <?php echo $option_color; ?>><?php echo $total; ?> <?php _e('votes', 'wppropoll'); ?></div>
            <?php
		}
		?>
	</div>
	
	<script type="text/javascript">
	jQuery(document).ready(function($){
		
		animate_results();
		
		function animate_results(){
			
			// Animate progress bar
			$(".poll-results-bar<?php echo $poll[0]->id; ?>").each(function(){
			  var percentage = $(this).data("value");
			  
			  <?php echo $poll[0]->progress_active_image ? "$(this).addClass('poll-result-bar-active');" : ""; ?>
		
			  $(this).css({width: '0%'}).animate({ width: percentage +'%'}, 2000, function() {
				  <?php echo $poll[0]->progress_active_image ? "$(this).removeClass('poll-result-bar-active');" : ""; ?>
			  });
			});
			
			// Animate percentage text
			$(".percent-progress<?php echo $poll[0]->id; ?>").each(function( inputKey, inputItem ){
				$({
					value: 0 //$(inputItem).text()
				}).animate({
					value: $(inputItem).data("value")
				}, {
					duration: 2000,
					step: function () {
						$(inputItem).text( Math.round(this.value) + '<?php echo $poll[0]->show_percentage == 1 ? ' '.__('votes', 'wppropoll') : '%'; ?>' );
					},
					complete: function() {
						$(inputItem).text( <?php if( $poll[0]->show_percentage == 2 ){ ?>$(inputItem).attr("votes") + ' <?php _e('votes', 'wppropoll'); ?> / '<?php } ?> + $(inputItem).data("value") + '<?php echo $poll[0]->show_percentage == 1 ? ' '.__('votes', 'wppropoll') : '%'; ?>' );
					},
				});
			});
			
		} // animate_results
		
	});
	</script>
	<?php
	}
	else
	{
		?>
        <div class="poll-results">
    		<h3 <?php echo $title_color; ?>><?php echo $poll[0]->title; ?></h3>
            <div <?php echo $option_color; ?>><?php _e('Thanks for voting','wppropoll'); ?></div>
        </div>
        <?php	
	}
}
?>